IterableBpGraphComponent< BAS > Class Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members
IterableBpGraphComponent< BAS > Class Template Reference

## Detailed Description

### template<typename BAS = BaseBpGraphComponent>
class lemon::concepts::IterableBpGraphComponent< BAS >

This class describes the interface of iterable undirected bipartite graphs. It extends IterableGraphComponent with the core iterable interface of undirected bipartite graphs. This concept is part of the BpGraph concept.

`#include <lemon/concepts/graph_components.h>`

Inheritance diagram for IterableBpGraphComponent< BAS >:
[legend]

## Public Types
Class Based Iteration
This interface provides iterator classes for red and blue nodes.
typedef GraphItemIt< BpGraph, RedNode > | RedNodeIt
| This iterator goes through each red node. More...
typedef GraphItemIt< BpGraph, BlueNode > | BlueNodeIt
| This iterator goes through each blue node. More...
Public Types inherited from IterableGraphComponent< BAS >
typedef GraphItemIt< Graph, Edge > | EdgeIt
| This iterator goes through each edge. More...
typedef GraphIncIt< Graph, Edge, Node, 'e'> | IncEdgeIt
| This iterator goes trough the incident edges of a node. More...
Public Types inherited from IterableDigraphComponent< BAS >
typedef GraphItemIt< Digraph, Node > | NodeIt
| This iterator goes through each node. More...
typedef GraphItemIt< Digraph, Arc > | ArcIt
| This iterator goes through each arc. More...
typedef GraphIncIt< Digraph, Arc, Node, 'i'> | InArcIt
| This iterator goes trough the incoming arcs of a node. More...
typedef GraphIncIt< Digraph, Arc, Node, 'o'> | OutArcIt
| This iterator goes trough the outgoing arcs of a node. More...

## Public Member Functions
Base Iteration
This interface provides functions for iteration on red and blue nodes.
void | first (RedNode &) const
| Return the first red node. More...
void | next (RedNode &) const
| Return the next red node. More...
void | first (BlueNode &) const
| Return the first blue node. More...
void | next (BlueNode &) const
| Return the next blue node. More...
Public Member Functions inherited from IterableGraphComponent< BAS >
void | first (Edge &) const
| Return the first edge. More...
void | next (Edge &) const
| Return the next edge. More...
void | firstInc (Edge &, bool &, const Node &) const
| Return the first edge incident to the given node. More...
void | nextInc (Edge &, bool &) const
| Gives back the next of the edges from the given node. More...
Node | baseNode (const IncEdgeIt &) const
| The base node of the iterator. More...
Node | runningNode (const IncEdgeIt &) const
| The running node of the iterator. More...
Public Member Functions inherited from IterableDigraphComponent< BAS >
void | first (Node &) const
| Return the first node. More...
void | next (Node &) const
| Return the next node. More...
void | first (Arc &) const
| Return the first arc. More...
void | next (Arc &) const
| Return the next arc. More...
void | firstIn (Arc &, const Node &) const
| Return the first arc incoming to the given node. More...
void | nextIn (Arc &) const
| Return the next arc incoming to the given node. More...
void | firstOut (Arc &, const Node &) const
| Return the first arc outgoing form the given node. More...
void | nextOut (Arc &) const
| Return the next arc outgoing form the given node. More...
Node | baseNode (const InArcIt &) const
| The base node of the iterator. More...
Node | runningNode (const InArcIt &) const
| The running node of the iterator. More...
Node | baseNode (const OutArcIt &) const
| The base node of the iterator. More...
Node | runningNode (const OutArcIt &) const
| The running node of the iterator. More...

## Member Typedef Documentation

typedef GraphItemIt<BpGraph, RedNode> RedNodeIt

This iterator goes through each red node.

typedef GraphItemIt<BpGraph, BlueNode> BlueNodeIt

This iterator goes through each blue node.

## Member Function Documentation

void first | ( | RedNode & |  | ) | const
| inline

This function gives back the first red node in the iteration order.

void next | ( | RedNode & |  | ) | const
| inline

This function gives back the next red node in the iteration order.

void first | ( | BlueNode & |  | ) | const
| inline

This function gives back the first blue node in the iteration order.

void next | ( | BlueNode & |  | ) | const
| inline

This function gives back the next blue node in the iteration order.